package com.advanstar.test.servlet;

import org.hornetq.core.config.Configuration;
import org.hornetq.core.config.impl.ConfigurationImpl;
import org.hornetq.core.remoting.impl.invm.InVMAcceptorFactory;
import org.hornetq.core.remoting.impl.invm.InVMConnectorFactory;
import org.hornetq.core.server.HornetQServer;
import org.hornetq.core.server.HornetQServers;
import org.hornetq.api.core.TransportConfiguration;
import org.hornetq.api.core.client.ClientSessionFactory;
import org.hornetq.api.core.client.HornetQClient;
import org.hornetq.api.core.client.ClientSession;
import org.apache.commons.lang.time.StopWatch;

/**
 * User: a_vijay
 * Date: Feb 8, 2010
 * Time: 11:20:11 PM
 * To change this template use File | Settings | File Templates.
 */
public class MessageSendAndReceive {

    public static final String QUEUE_NAME = "queue.TestQueue8";
    private static void loadMServer(){
        try{
          Configuration configuration = new ConfigurationImpl();
          configuration.setPersistenceEnabled(true);
          configuration.setSecurityEnabled(false);
          configuration.setBindingsDirectory("D:/hq/bindings");
          configuration.setJournalDirectory("D:/hq/journal");


          //configuration.set
          configuration.getAcceptorConfigurations().add(new TransportConfiguration(InVMAcceptorFactory.class.getName()));

          // Step 2. Create and start the server
          HornetQServer server = HornetQServers.newHornetQServer(configuration);
          server.start();

          // Step 3. As we are not using a JNDI environment we instantiate the objects directly
          ClientSessionFactory sf = HornetQClient.createClientSessionFactory(new TransportConfiguration(InVMConnectorFactory.class.getName()));


          // Step 4. Create a core queue
          ClientSession coreSession = sf.createSession(false, false, false);

          //final String queueName = "queue.TestQueue4";
          //coreSession.queueQuery()

          coreSession.createQueue(QUEUE_NAME, QUEUE_NAME, true);
          coreSession.close();

          System.err.println("**********Server Started***********");
          System.err.println(" initialised with JMS Queue" );
        }catch(Exception ex) {
            ex.printStackTrace();
        }

    }

    public static void main(String[] args) throws Exception{
        loadMServer();
        StopWatch stopWatch = new StopWatch();
        stopWatch.start();


//        MessageReceiver receiver = new MessageReceiver();
//        receiver.receiveMessage();

        MessagePusher pusher = new MessagePusher();
        pusher.sendMessage(0);


        Thread.sleep(1000);
        pusher.sendMessage(130);

        Thread.sleep(1000);

        pusher.sendMessage(260);

        Thread.sleep(1000);

         pusher.sendMessage(390);

        pusher.sendMessage(520);

        stopWatch.stop();
        System.out.println("Timetook for Processing==> " + stopWatch.toString());


        //pusher.sendMessage();





    }
}
